<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item label="申请GUID" prop="applGuid">
        <el-input v-model="queryParams.applGuid" placeholder="请输入申请GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="验证结果" prop="veriResu">
        <el-select v-model="queryParams.veriResu" placeholder="请选择验证结果" clearable>
          <el-option v-for="dict in eutr_firs_resu" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['stan:fromfirsttria:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['stan:fromfirsttria:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['stan:fromfirsttria:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['stan:fromfirsttria:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="stan-fromfirsttria-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="初审编号" prop="fromFirsttriaCode" />
      <el-table-column label="验证意见" prop="veriOpin" />
      <el-table-column label="验证结果" prop="veriResu" width="120">
        <template #default="scope">
          <dict-tag :options="eutr_firs_resu" :value="scope.row.veriResu" />
        </template>
      </el-table-column>
      <el-table-column label="验证日期" prop="veriDate" width="180" />
      <el-table-column label="验证人" prop="veriPers" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['stan:fromfirsttria:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['stan:fromfirsttria:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="申请GUID" prop="applGuid">
          <el-input v-model="form.applGuid" placeholder="请输入申请GUID" />
        </el-form-item>
        <el-form-item label="初审编号" prop="fromFirsttriaCode">
          <el-input v-model="form.fromFirsttriaCode" placeholder="请输入初审编号" />
        </el-form-item>
        <el-form-item label="验证意见" prop="veriOpin">
          <el-input v-model="form.veriOpin" type="textarea" placeholder="请输入验证意见" />
        </el-form-item>
        <el-form-item label="验证结果" prop="veriResu">
          <el-select v-model="form.veriResu" placeholder="请选择验证结果">
            <el-option v-for="dict in eutr_firs_resu" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="验证日期" prop="veriDate">
          <el-date-picker v-model="form.veriDate" type="datetime" placeholder="选择验证日期" clearable />
        </el-form-item>
        <el-form-item label="验证人" prop="veriPers">
          <el-input v-model="form.veriPers" placeholder="请输入验证人" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="FromFirsttria">
import { listBisFromFirsttria, getBisFromFirsttria, addBisFromFirsttria, updateBisFromFirsttria, delBisFromFirsttria } from "@/api/slaj/stan";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { eutr_firs_resu } = proxy.useDict("eutr_firs_resu");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ fromFirsttriaCode: { visible: true }, veriOpin: { visible: true }, veriResu: { visible: true }, veriDate: { visible: true }, veriPers: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, applGuid: null, veriResu: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisFromFirsttria(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加初审";
}

function handleUpdate(row) {
  reset();
  getBisFromFirsttria(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改初审";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisFromFirsttria(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisFromFirsttria(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisFromFirsttria(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/stan/fromfirsttria/export', { ...queryParams.value }, `初审_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, applGuid: null, fromFirsttriaCode: null, veriOpin: null, veriResu: null, veriDate: null, veriPers: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
